'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AssignmentReminder = function () {
  function AssignmentReminder() {
    _classCallCheck(this, AssignmentReminder);

    this.hasExportDefault = false;
    this.hasExportNamed = false;
  }

  _createClass(AssignmentReminder, [{
    key: 'evaluateExpression',
    value: function evaluateExpression(path) {
      var property = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'expression';

      // Not `exports.anything`, skip
      if (!path.get(property + '.left').node || !path.get(property + '.left.object').node) {
        return;
      }

      var objectName = path.get(property + '.left.object.name').node;
      var propertyName = path.get(property + '.left.property.name').node;
      var name = objectName + '.' + propertyName;
      if (name === 'exports.default') {
        this.hasExportDefault = true;
      } else if (objectName === 'exports') {
        this.hasExportNamed = true;
      }
    }
  }]);

  return AssignmentReminder;
}();

module.exports = function (_ref) {
  var types = _ref.types;
  return {
    visitor: {
      CallExpression: {
        exit: function exit(path, state) {
          // Not `Object.defineProperty`, skip
          if (!path.get('callee.object').node) {
            return;
          }

          var callee = path.get('callee.object.name').node + '.' + path.get('callee.property.name').node;
          var args = path.get('arguments').map(function (path) {
            if (path.isStringLiteral()) {
              return path.get('value').node;
            }
            if (path.get('properties').length) {
              return path.get('properties.0.key.name').node + ':' + path.get('properties.0.value.value').node;
            }
          }).join(' ');

          var isLegacyModule = '' + callee + args === 'Object.defineProperty __esModule value:true';
          if (isLegacyModule) {
            var reminder = new AssignmentReminder();
            var program = path.parentPath.parentPath;
            program.get('body').forEach(function (path) {
              if (path.isVariableDeclaration()) {
                reminder.evaluateExpression(path.get('declarations.0'), 'init');
              } else {
                if (path.isExpressionStatement() && path.get('expression').isAssignmentExpression()) {
                  reminder.evaluateExpression(path);
                }
              }
            });

            if (reminder.hasExportDefault && !reminder.hasExportNamed) {
              program.pushContainer('body', [types.expressionStatement(types.assignmentExpression('=', types.memberExpression(types.identifier('module'), types.identifier('exports')), types.memberExpression(types.identifier('exports'), types.stringLiteral('default'), true)))]);
            }
            if (state.opts.addDefaultProperty) {
              program.pushContainer('body', [types.expressionStatement(types.assignmentExpression('=', types.memberExpression(types.memberExpression(types.identifier('module'), types.identifier('exports')), types.identifier('default')), types.memberExpression(types.identifier('exports'), types.stringLiteral('default'), true)))]);
            }
          }
        }
      }
    }
  };
};
//# sourceMappingURL=index.js.map